﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Main.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Простые примеры отправки асинхронных запросов - Kbyte.Ru
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">

    <script language="javascript" type="text/javascript">
      // -------------------------------------------------------------
      // -------------------------------------------------------------
      // простой пример отправки запроса методом GET
      function SendRequest() {
        $.ajax({url: "/AjaxHelloWorld.aspx", success: SendRequest_Success, error: Error, complete: SendRequest_Сomplete});
      }
      function SendRequest_Success(result) {
        $("#serverResponse").html(result);
      }
      function SendRequest_Сomplete(x, status) {
        alert(status + ": " + x.responseText);
      }
      // -------------------------------------------------------------

      // -------------------------------------------------------------
      // -------------------------------------------------------------
      // пример обработки ответов сервера для разных кодов состояния
      // -------------------------------------------------------------
      function StatusCodeExample(path) {
        $.ajax(path, { statusCode: 
          {
            200: StatusCodeExample_200,
            404: StatusCodeExample_404,
            500: StatusCodeExample_500
          }
        });
      }
      function StatusCodeExample_200(result) {
        alert(result);
      }
      function StatusCodeExample_404() {
        alert("Страница не найдена!");
      }
      function StatusCodeExample_500() {
        alert("Ошибка сервера!");
      }
      // -------------------------------------------------------------

      // -------------------------------------------------------------
      // -------------------------------------------------------------
      // простой пример отправки запроса методом POST
      function SendPostRequest() {
        $.ajax("/AjaxPost.aspx", {type: "POST", data: {name: "Kbyte.Ru", age: 6, url: "http://kbyte.ru"}, success: SendPostRequest_Success, error: Error });
      }

      function SendPostRequest_Success(result) {
        alert(result);
      }

      // -------------------------------------------------------------
      // -------------------------------------------------------------
      // простой пример отправки запроса методом POST и получения JSON-данных
      function JsonExample() {
        $.post("/JsonExample.aspx", JsonExample_Success);
      }
      function JsonExample_Success(result) {
        var text = "";
        text += "Статус: " + result.status + "\r\n";
        for (var i = 0; i <= result.table.length - 1; i++) {
          text += "Имя: " + result.table[i].firstName + "; Фамилия: " + result.table[i].lastName + "; Пол: " + result.table[i].sex + "\r\n";
        }
        alert(text);
      }

      // -------------------------------------------------------------
      // -------------------------------------------------------------
      // метод обратного вызова для обработки ошибок, общий для всех запросов
      function Error(x, status, message) {
        alert(status + ": " + message);
      }
    </script>

    <a href="#" onclick="SendRequest();return false;">Отправить простой асинхронный запрос</a><br /><br />
    <a href="#" onclick="StatusCodeExample('/AjaxHelloWorld.aspx');return false;">Отправить запрос с обработкой кода состояния (200)</a><br />
    <a href="#" onclick="StatusCodeExample('/Несуществующая страница');return false;">Отправить запрос с обработкой кода состояния (404)</a><br /><br />

    <a href="#" onclick="SendPostRequest();return false;">Отправить POST-запрос</a><br /><br />

    <a href="#" onclick="JsonExample();return false;">Отправить POST-запрос и получить JSON-данные</a><br /><br />

    <div id="serverResponse"></div>


</asp:Content>
